# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
	module S4u_weld
		def self.find_vertices(edges_new1)
			edges_new=edges_new1.clone
			i=0
			list=[]
			list1=[]
			while (edges_new.length>0) && (i<edges_new1.length)
				vers=edges_new.flat_map{|e| e.vertices}.uniq
				ls=[]
				if f=vers.find{|v| (l=(v.edges & edges_new1).length )&& l && ((l==1) ||(l>2) )}
					ls<<f
					vers.delete f
				elsif f=vers.find{|v| (l=(v.edges ).length )&& l && ((l==1) || (l>2))}
					ls<<f
					vers.delete f
				elsif f=vers.find{|v| (v.edges & edges_new).length==1}
					ls<<f
					vers.delete f
				else
					ls<< vers.shift
				end
				length=vers.length
				j=0
				while (edges_new.length>0) && (j<length) && (vers.length>0)
					j+=1
					vs=ls.last.edges.flat_map{|e| e.vertices} & vers
					lc=vs.find{|l|
							l.common_edge(ls.last) &&
							((l.edges & ls.last.edges) & edges_new).length==1
						}
					if lc
						led=(lc.edges & ls.last.edges) & edges_new
						edges_new-=led
						ls<< lc
						vers.delete(lc)
						break if ((lc.edges & edges_new1).length>2)
					end
				end
				if ls.length<=2
					list1 << ls
				else
					list << ls
				end
				Sketchup.status_text= Strings["Processing"] +": " +(edges_new1.length-edges_new.length).to_s + "/" + edges_new1.length.to_s
				i+=(ls.length-1)
			end
			j=0
			length=list1.length
			while list1.length>0 && j<length
					ls1=list1[0]
					list.each_index{|i|
						if ((ls1 & list[i]).length==2) && (((list[i][0].edges & list[i][-1].edges) & edges_new1).length==1)
							if (list[i][0].edges).length>(list[i][-1].edges).length
								list[i]<<list[i][0]
								list1.delete_at(0)
								break
							elsif (list[i][0].edges ).length<(list[i][-1].edges ).length
								list[i].unshift list[i][-1]
								list1.delete_at(0)
								break
							elsif (list[i][0].edges & edges_new1).length>(list[i][-1].edges & edges_new1).length
								list[i]<<list[i][0]
								list1.delete_at(0)
								break
							elsif (list[i][0].edges & edges_new1).length<(list[i][-1].edges & edges_new1).length
								list[i].unshift list[i][-1]
								list1.delete_at(0)
								break

							elsif ls1[0]==list[i][0] && ls1[-1]==list[i][-1]#&& ls1[0].edges.select{|e|!(e.soft? || e.hidden?)}.length<=2 &&
								#ls1[1].edges.select{|e|!(e.soft? || e.hidden?)}.length<=2
								list[i]<<ls1[0]
								list1.delete_at(0)
								break
							elsif ls1[0]==list[i][-1] && ls1[-1]==list[i][0] #&& ls1[0].edges.select{|e|!(e.soft? || e.hidden?)}.length<=2 &&
								#ls1[1].edges.select{|e|!(e.soft? || e.hidden?)}.length<=2
								list[i]<<ls1[-1]
								list1.delete_at(0)
								break
							end
						end
					}
				j+=1
			end
			return (list + list1)
		end
		def self.find_all_connected(edges)
			edges1=edges.clone
			i=0;list=[]
			while (edges1.length>0) && (i<edges.length)
				ls=[]
				if f=edges1.find{|e| e.vertices[0].edges.length==1 || e.vertices[1].edges.length==1}
					ls<<f
					edges1.delete f
				else
					ls<<edges1.shift
				end
				allconnect= (ls.last.all_connected) & edges
				ls+=allconnect
				ls.uniq!
				list<< ls
				edges1-=ls
				i+=1
			end
			return list
			rescue =>error
                p error,error.backtrace.join('\n')
			    return edges
		end
		def self.weld(mode)
			@limit_edges=2000
			model=Sketchup.active_model
			entities=model.active_entities
			edges=[]
			sel=model.selection.select{|e| e && e.valid?}
			edges=sel.grep(Sketchup::Edge)
			edges_face=sel.grep(Sketchup::Face).collect{|f| f.loops.collect{|l| l.edges}}.flatten
			edges=edges_face+(edges-edges_face)
			edges=edges.select{|e| e if !(e.hidden? || e.soft?)}.uniq
			if edges.empty?
				(p "empty selection" ;return )
			elsif (edges.length > @limit_edges) && (Sketchup.version.to_f < 20.1)
				id=UI.messagebox Strings["Selected edges too much. Do you want to continue?"],MB_OKCANCEL
				return if id!=1
			end
			model.start_operation TOOL,true,false,false
				curs=0
				if (Sketchup.version.to_f < 20.1) #|| (edges.length==1)
					g=entities.add_group
					ins_edges=[]
					if edges.length>0
						Sketchup.status_text= Strings["Processing Find Edges"]
						edge_list_connected= find_all_connected edges
						ver_list_connected=edge_list_connected.collect{|eds| find_vertices(eds)}
						ver_list=ver_list_connected.flatten(1)
						inum=0
						ver_list_connected.each{|eds|
							eds.each{|ed|
								inum+=1
								if ed.length>1
									points=ed
									# if points[0].common_edge(points[-1]) &&
										# (((points[0].edges & points[-1].edges) & edges).length==1) &&
										# ((points[0].edges & edges).length <3)
										# points << points[0]
									# end
									g.entities.add_curve points
									curs+=1
								end
								Sketchup.status_text= Strings["Processing Cuver"] + " : " +
														inum.to_s + "/" + ver_list.length.to_s
							}
						}
						model.selection.clear
						if (mode==0) && g && g.valid?
							count=[]
							ver_list.each{|ed|
								eds=ed.flat_map{|e| e.edges} & edges
								eds.each{|e| ( e.explode_curve) if e && e.valid? &&  e.curve}
							}
							curve=[]
							count+=g.explode
							count.each{|e|
								if e && e.valid? && e.is_a?(Sketchup::Curve)
									curve << e
									 model.selection.add e.edges
								end
							}
						elsif g && g.valid?
							model.selection.add g
						end
					end
				else
					if (mode==0)
						model.selection.clear
						curvers=model.active_entities.weld(edges)
						model.selection.add curvers.collect{|e| e.edges}
						curs=curvers.length
					else
						g=entities.add_group edges
						curvers= g.entities.weld (g.entities.grep(Sketchup::Edge))
						model.selection.add g
						curs=curvers.length
					end
				end
			p ("Weld " + curs.to_s + " curves")
			model.commit_operation
			rescue =>error
                p error,error.backtrace.join('\n')
			    model.abort_operation
		end
		def self.main(mode=0)
			self.weld(mode)
		end
	end
end